/* keyword.h */

/* Copyright (C) 2006 Niels Mller
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef NXT_KEYWORD_H
#define NXT_KEYWORD_H

enum keyword {
  /* These values are the actual opcodes */
  KEYWORD_ADD	= 0x00,
  KEYWORD_SUB	= 0x01,
  KEYWORD_NEG	= 0x02,
  KEYWORD_MUL	= 0x03,
  KEYWORD_DIV	= 0x04,
  KEYWORD_MOD	= 0x05,
  KEYWORD_AND	= 0x06,
  KEYWORD_OR 	= 0x07,
  KEYWORD_XOR	= 0x08,
  KEYWORD_NOT	= 0x09,

  KEYWORD_JMP	= 0x25,
  KEYWORD_BRCMP	= 0x26,
  KEYWORD_BRTST	= 0x27,
  KEYWORD_STOP	= 0x29,
  KEYWORD_FINCLUMP	= 0x2a,
  KEYWORD_FINCLUMPIMMED = 0x2b,
  KEYWORD_AQUIRE	= 0x2c,
  KEYWORD_RELEASE	= 0x2d,
  KEYWORD_SUBCALL	= 0x2e,
  KEYWORD_SUBRET	= 0x2f,
  
  /* These values are 0x100 + the DSTOC code */
  KEYWORD_BYTE	= 0x101,
  KEYWORD_SBYTE	= 0x102,
  KEYWORD_WORD	= 0x103,
  KEYWORD_SWORD	= 0x104,
  KEYWORD_LONG	= 0x105,
  KEYWORD_SLONG 	= 0x106,
  KEYWORD_ARRAY	= 0x107,
  KEYWORD_CLUSTER	= 0x108,
  KEYWORD_MUTEX	= 0x109,

  /* Pseudo operations */
  KEYWORD_CLUMP = 0x200,  
};

struct keyword_assoc
{
  const char *name;
  enum keyword id;
  int type;
};

const struct keyword_assoc *
keyword_lookup (const char *str, unsigned int len);

#endif /* NXT_KEYWORD_H */
