/* record.h */

/* Copyright (C) 2006 Niels Mller
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of the
 * License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef NXT_RECORD_H
#define NXT_RECORD_H

#include "keyword.h"

struct record
{
  struct record *next;
  struct record *prev;

  unsigned address;
  unsigned size;
  unsigned align;

  /* Index in the dataspace table of contents */
  unsigned index;

  /* FIXME: Sufficient for scalars; more information is needed for
     arrays and clusters */
  enum keyword type;

  /* Initial value */
  long value;
};

struct record *
record_scalar_create (enum keyword op, long value);

#endif /* NXT_RECORD_H */
